# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`sendmail`](#sendmail): Manage the Sendmail MTA.
* [`sendmail::access`](#sendmailaccess): Manage the Sendmail access db file.
* [`sendmail::access::file`](#sendmailaccessfile): Manage the Sendmail access db file.
* [`sendmail::aliases`](#sendmailaliases): Manage the Sendmail aliases file.
* [`sendmail::aliases::file`](#sendmailaliasesfile): Create the Sendmail aliases file.
* [`sendmail::authinfo`](#sendmailauthinfo): Manage the Sendmail authinfo db file.
* [`sendmail::authinfo::file`](#sendmailauthinfofile): Create the Sendmail authinfo db file.
* [`sendmail::domaintable`](#sendmaildomaintable): Manage the Sendmail domaintable db file.
* [`sendmail::domaintable::file`](#sendmaildomaintablefile): Manage the Sendmail domaintable db file.
* [`sendmail::genericstable`](#sendmailgenericstable): Manage the Sendmail genericstable db file.
* [`sendmail::genericstable::file`](#sendmailgenericstablefile): Manage the Sendmail genericstable db file.
* [`sendmail::mailertable`](#sendmailmailertable): Manage the Sendmail mailertable db file.
* [`sendmail::mailertable::file`](#sendmailmailertablefile): Manage the Sendmail mailertable db file.
* [`sendmail::makeall`](#sendmailmakeall): Rebuild all config files for the Sendmail MTA using a Makefile
* [`sendmail::mc::privacy_flags`](#sendmailmcprivacy_flags): Manage privacy flags for the Sendmail MTA
* [`sendmail::mc::timeouts`](#sendmailmctimeouts): Manage various timeout settings in the 'sendmail.mc' file.
* [`sendmail::mc::trust_auth_mech`](#sendmailmctrust_auth_mech): Add the `TRUST_AUTH_MECH` macro to the sendmail.mc file.
* [`sendmail::nullclient`](#sendmailnullclient): Create a simple Sendmail nullclient configuration.
* [`sendmail::userdb`](#sendmailuserdb): Manage the Sendmail userdb db file.
* [`sendmail::userdb::file`](#sendmailuserdbfile): Manage the Sendmail userdb file.
* [`sendmail::virtusertable`](#sendmailvirtusertable): Manage the Sendmail virtusertable db file.
* [`sendmail::virtusertable::file`](#sendmailvirtusertablefile): Manage the Sendmail virtusertable db file.

#### Private Classes

* `sendmail::aliases::newaliases`: Rebuild the Sendmail aliases file.
* `sendmail::local_host_names`: Manage entries in the Sendmail local-host-names file.
* `sendmail::mc`: Manage the sendmail.mc file
* `sendmail::mc::define_section`: Add a section header to improve readability of the config file
* `sendmail::mc::enhdnsbl_section`: Add a section header to improve readability of the config file
* `sendmail::mc::feature_section`: Add a section header to improve readability of the config file
* `sendmail::mc::ldap_section`: Add a section header above the ldap settings
* `sendmail::mc::local_config_section`: Add a section header to improve readability of the config file
* `sendmail::mc::macro_section`: Add a section header to improve readability of the config file
* `sendmail::mc::mailer_section`: Add a section header to improve readability of the config file
* `sendmail::mc::milter_section`: Add a section header to improve readability of the config file
* `sendmail::mc::queue_group_section`: Add a section header to improve readability of the config file
* `sendmail::mc::starttls`: Manage `STARTTLS` parameters in the 'sendmail.mc' file.
* `sendmail::package`: Manage the Sendmail MTA package.
* `sendmail::params`: The parameters used when setting up the Sendmail MTA.
* `sendmail::relay_domains`: Manage entries in the Sendmail relay-domains file.
* `sendmail::service`: Manage the Sendmail service.
* `sendmail::submit`: Manage the submit.mc file for the Sendmail submission program.
* `sendmail::trusted_users`: Manage entries in the Sendmail trusted-users file.

### Defined types

* [`sendmail::access::entry`](#sendmailaccessentry): Manage an entry in the Sendmail access db file.
* [`sendmail::aliases::entry`](#sendmailaliasesentry): Manage an entry in the Sendmail alias file.
* [`sendmail::authinfo::entry`](#sendmailauthinfoentry): Manage an entry in the Sendmail authinfo db file.
* [`sendmail::domaintable::entry`](#sendmaildomaintableentry): Manage an entry in the Sendmail domaintable file.
* [`sendmail::genericstable::entry`](#sendmailgenericstableentry): Manage an entry in the Sendmail genericstable file.
* [`sendmail::mailertable::entry`](#sendmailmailertableentry): Manage an entry in the Sendmail mailertable file.
* [`sendmail::mc::daemon_options`](#sendmailmcdaemon_options): Add the `DAEMON_OPTIONS` macro to the sendmail.mc file.
* [`sendmail::mc::define`](#sendmailmcdefine): Add m4 macro defines to the sendmail.mc file.
* [`sendmail::mc::domain`](#sendmailmcdomain): Add the `DOMAIN` macro to the sendmail.mc file.
* [`sendmail::mc::enhdnsbl`](#sendmailmcenhdnsbl): Manage enhanced DNS blacklist entries
* [`sendmail::mc::feature`](#sendmailmcfeature): Add the `FEATURE` macro to the sendmail.mc file.
* [`sendmail::mc::generics_domain`](#sendmailmcgenerics_domain): Add the `GENERICS_DOMAIN` macro to the sendmail.mc file.
* [`sendmail::mc::include`](#sendmailmcinclude): Add include fragments to the sendmail.mc file.
* [`sendmail::mc::ldaproute_domain`](#sendmailmcldaproute_domain): Add the `LDAPROUTE_DOMAIN` macro to the sendmail.mc file.
* [`sendmail::mc::local_config`](#sendmailmclocal_config): Add a `LOCAL_CONFIG` section into the sendmail.mc file.
* [`sendmail::mc::mailer`](#sendmailmcmailer): Add a `MAILER` macro to the sendmail.mc file.
* [`sendmail::mc::masquerade_as`](#sendmailmcmasquerade_as): Add the `MASQUERADE_AS` macro to the sendmail.mc file.
* [`sendmail::mc::milter`](#sendmailmcmilter): Manage Sendmail Milter configuration in sendmail.mc
* [`sendmail::mc::modify_mailer_flags`](#sendmailmcmodify_mailer_flags): Add a `MODIFY_MAILER_FLAGS` macro to the sendmail.mc file.
* [`sendmail::mc::ostype`](#sendmailmcostype): Add the `OSTYPE` macro to the sendmail.mc file.
* [`sendmail::mc::queue_group`](#sendmailmcqueue_group): Add the `QUEUE_GROUP` macro to the sendmail.mc file.
* [`sendmail::mc::versionid`](#sendmailmcversionid): Add the `VERSIONID` macro to the sendmail.mc file.
* [`sendmail::mc::virtuser_domain`](#sendmailmcvirtuser_domain): Add the `VIRTUSER_DOMAIN` macro to the sendmail.mc file.
* [`sendmail::userdb::entry`](#sendmailuserdbentry): Manage an entry in the Sendmail userdb file.
* [`sendmail::virtusertable::entry`](#sendmailvirtusertableentry): Manage an entry in the Sendmail virtusertable db file.

### Functions

* [`sendmail::canonify_array`](#sendmailcanonify_array): Canonify an array

### Data types

* [`Sendmail::DHParam`](#sendmaildhparam): The valid number of bits for DH params.
* [`Sendmail::Deliverymode`](#sendmaildeliverymode): The supported delivery modes for Sendmail.
* [`Sendmail::Loglevel`](#sendmailloglevel): The supported loglevels.
* [`Sendmail::Messagesize`](#sendmailmessagesize): A message size specification in bytes, kb or Mb.
* [`Sendmail::Timeout`](#sendmailtimeout): A timeout specification in seconds or minutes.

## Classes

### <a name="sendmail"></a>`sendmail`

Perform the basic setup and installation of Sendmail on the system.

#### Examples

##### 

```puppet
class { 'sendmail': }
```

#### Parameters

The following parameters are available in the `sendmail` class:

* [`smart_host`](#smart_host)
* [`domain_name`](#domain_name)
* [`max_message_size`](#max_message_size)
* [`log_level`](#log_level)
* [`dont_probe_interfaces`](#dont_probe_interfaces)
* [`features`](#features)
* [`enable_ipv4_daemon`](#enable_ipv4_daemon)
* [`enable_ipv6_daemon`](#enable_ipv6_daemon)
* [`mailers`](#mailers)
* [`local_host_names`](#local_host_names)
* [`relay_domains`](#relay_domains)
* [`trusted_users`](#trusted_users)
* [`trust_auth_mech`](#trust_auth_mech)
* [`ca_cert_file`](#ca_cert_file)
* [`ca_cert_path`](#ca_cert_path)
* [`server_cert_file`](#server_cert_file)
* [`server_key_file`](#server_key_file)
* [`client_cert_file`](#client_cert_file)
* [`client_key_file`](#client_key_file)
* [`server_cert_file2`](#server_cert_file2)
* [`server_key_file2`](#server_key_file2)
* [`client_cert_file2`](#client_cert_file2)
* [`client_key_file2`](#client_key_file2)
* [`crl_file`](#crl_file)
* [`dh_params`](#dh_params)
* [`tls_srv_options`](#tls_srv_options)
* [`cipher_list`](#cipher_list)
* [`server_ssl_options`](#server_ssl_options)
* [`client_ssl_options`](#client_ssl_options)
* [`cf_version`](#cf_version)
* [`version_id`](#version_id)
* [`msp_host`](#msp_host)
* [`msp_port`](#msp_port)
* [`enable_msp_trusted_users`](#enable_msp_trusted_users)
* [`manage_sendmail_mc`](#manage_sendmail_mc)
* [`manage_submit_mc`](#manage_submit_mc)
* [`auxiliary_packages`](#auxiliary_packages)
* [`package_ensure`](#package_ensure)
* [`package_manage`](#package_manage)
* [`service_name`](#service_name)
* [`service_enable`](#service_enable)
* [`service_manage`](#service_manage)
* [`service_ensure`](#service_ensure)
* [`service_hasstatus`](#service_hasstatus)

##### <a name="smart_host"></a>`smart_host`

Data type: `Optional[String]`

Servers that are behind a firewall may not be able to
deliver mail directly to the outside world.  In this case the host may
need to forward the mail to the gateway machine defined by this
parameter.  All nonlocal mail is forwarded to this gateway.

Default value: ``undef``

##### <a name="domain_name"></a>`domain_name`

Data type: `Optional[String]`

Sets the official canonical name of the local machine.
Normally this parameter is not required as Sendmail uses the fully
qualified domain name by default.  Setting this parameter will override
the value of the `$j` macro in the sendmail.cf file.

Default value: ``undef``

##### <a name="max_message_size"></a>`max_message_size`

Data type: `Optional[String]`

Define the maximum message size that will be
accepted.  This can be a pure numerical value given in bytes
(e.g. 33554432) or a number with a prefixed byte unit (e.g. 32MB).  The
conversion is done using the 1024 convention (see the `to_bytes` function
in the `stdlib` module), so valid prefixes are either `k` for 1024 bytes
or `M` for 1048576 bytes.

Default value: ``undef``

##### <a name="log_level"></a>`log_level`

Data type: `Optional[Sendmail::Loglevel]`

The loglevel for the sendmail process.  Valid options:
a numeric value.

Default value: ``undef``

##### <a name="dont_probe_interfaces"></a>`dont_probe_interfaces`

Data type: `Optional[Boolean]`

Sendmail normally probes all network
interfaces to get the hostnames that the server may have.  These
hostnames are then considered local.  This option can be used to prevent
the reverse lookup of the network addresses.  If this option is set to
`localhost` then all network interfaces except for the loopback interface
is probed.  Valid options: the strings `true`, `false` or `localhost`.

Default value: ``undef``

##### <a name="features"></a>`features`

Data type: `Hash[String,Data]`

A hash of features to include in the configuration.  Each
hash key should be a feature name while the value should be a hash
itself.  The value hash is used as parameters for the
`sendmail::mc::feature` defined type.  Check the documentation of this
type for details.

Some features (e.g. `mailertable`, `access_db`, ...) may need to be
managed individually. So the `mailertable` feature could be enabled using
this parameter but that does not manage the mailertable file itself. So
in addition you would have to use the `sendmail::mailertable` class or
the `sendmail::mailertable::entry` defined type.

Default value: `{}`

##### <a name="enable_ipv4_daemon"></a>`enable_ipv4_daemon`

Data type: `Boolean`

Should the host accept mail on all IPv4 network
adresses.  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="enable_ipv6_daemon"></a>`enable_ipv6_daemon`

Data type: `Boolean`

Should the host accept mail on all IPv6 network
adresses.  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="mailers"></a>`mailers`

Data type: `Array[String]`

An array of mailers to add to the configuration.  The
default is `[ 'smtp', 'local' ]`.

Default value: `$sendmail::params::mailers`

##### <a name="local_host_names"></a>`local_host_names`

Data type: `Array[String]`

An array of hostnames that Sendmail considers for
a local delivery.

Default value: `[$facts['networking']['fqdn']]`

##### <a name="relay_domains"></a>`relay_domains`

Data type: `Array[String]`

An array of domains that Sendmail accepts as relay
target.  This setting is required for secondary MX setups.

Default value: `[]`

##### <a name="trusted_users"></a>`trusted_users`

Data type: `Array[String]`

An array of user names that will be written into the
trusted users file.  Leading or trailing whitespace is ignored.  Empty
entries are also ignored.

Default value: `[]`

##### <a name="trust_auth_mech"></a>`trust_auth_mech`

Data type: `Optional[Variant[String,Array[String]]]`

The value of the `TRUST_AUTH_MECH` macro to set.  If
this is a string it is used as-is.  For an array the value will be
concatenated into a string.

Default value: ``undef``

##### <a name="ca_cert_file"></a>`ca_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL CA certificate.

Default value: ``undef``

##### <a name="ca_cert_path"></a>`ca_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

The directory where SSL CA certificates are kept.

Default value: ``undef``

##### <a name="server_cert_file"></a>`server_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL server certificate for
inbound connections.

Default value: ``undef``

##### <a name="server_key_file"></a>`server_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL server key for inbound
connections.

Default value: ``undef``

##### <a name="client_cert_file"></a>`client_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL client certificate for
outbound connections.

Default value: ``undef``

##### <a name="client_key_file"></a>`client_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL client key for outbound
connections.

Default value: ``undef``

##### <a name="server_cert_file2"></a>`server_cert_file2`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the secondary SSL server
certificate for inbound connections.  The parameter is only valid on
Sendmail 8.15.1 or later and when `server_cert_file` is set.

Default value: ``undef``

##### <a name="server_key_file2"></a>`server_key_file2`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the secondary SSL server key for
inbound connections.  The parameter is only valid on Sendmail 8.15.1 or
later and when `server_key_file` is set.

Default value: ``undef``

##### <a name="client_cert_file2"></a>`client_cert_file2`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the secondary SSL client
certificate for outbound connections.  The parameter is only valid on
Sendmail 8.15.1 or later and when `client_cert_file` is set.

Default value: ``undef``

##### <a name="client_key_file2"></a>`client_key_file2`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the secondary SSL client key for
outbound connections.  The parameter is only valid on Sendmail 8.15.1 or
later and when `client_key_file` is set.

Default value: ``undef``

##### <a name="crl_file"></a>`crl_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename with a list of revoked certificates.

Default value: ``undef``

##### <a name="dh_params"></a>`dh_params`

Data type: `Optional[Sendmail::DHParam]`

The DH parameters used for encryption.  This can be one of
the numbers `512`, `1024`, `2048` or a filename with generated
parameters.

Default value: ``undef``

##### <a name="tls_srv_options"></a>`tls_srv_options`

Data type: `Optional[Enum['V','']]`

The parameter adjusts the server TLS settings.  This
can currently be either the letter `V` or the empty string.  Setting this
parameter to `V` disables the request for a client certificate.

Default value: ``undef``

##### <a name="cipher_list"></a>`cipher_list`

Data type: `Optional[String]`

Set the available ciphers for encrypted connections.

Default value: ``undef``

##### <a name="server_ssl_options"></a>`server_ssl_options`

Data type: `Optional[String]`

Configure the SSL connection flags for inbound
connections.

Default value: ``undef``

##### <a name="client_ssl_options"></a>`client_ssl_options`

Data type: `Optional[String]`

Configure the SSL connection flags for outbound
connections.

Default value: ``undef``

##### <a name="cf_version"></a>`cf_version`

Data type: `Optional[String]`

The configuration version string for Sendmail.  This
string will be appended to the Sendmail version in the `HELO` message.
If unset, no configuration version will be used.

Default value: ``undef``

##### <a name="version_id"></a>`version_id`

Data type: `Optional[String]`

The version id string included in the sendmail.mc file.
This has no practical meaning other than having a used defined identifier
in the file.

Default value: ``undef``

##### <a name="msp_host"></a>`msp_host`

Data type: `String`

The host where the message submission program should
deliver to.  This can be a hostname or IP address.  To prevent MX lookups
for the host, put it in square brackets (e.g., `[hostname]`).  Delivery
to the local host would therefore use either `[127.0.0.1]` for IPv4 or
`[IPv6:::1]` for IPv6.

Default value: `'[127.0.0.1]'`

##### <a name="msp_port"></a>`msp_port`

Data type: `Pattern[/^(MSA)|([0-9]+)$/]`

The port used for the message submission program.  Can be
a port number (e.g., `25`) or the literal `MSA` for delivery to the
message submission agent on port 587.

Default value: `'MSA'`

##### <a name="enable_msp_trusted_users"></a>`enable_msp_trusted_users`

Data type: `Boolean`

Whether the trusted users file feature is
enabled for the message submission program.  This may be necessary if you
want to allow certain users to change the sender address using `sendmail
-f`.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="manage_sendmail_mc"></a>`manage_sendmail_mc`

Data type: `Boolean`

Whether to automatically manage the `sendmail.mc`
file.  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="manage_submit_mc"></a>`manage_submit_mc`

Data type: `Boolean`

Whether to automatically manage the `submit.mc`
file.  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="auxiliary_packages"></a>`auxiliary_packages`

Data type: `Array[String]`

Additional packages that will be installed by the
Sendmail module.  Valid options: array of strings.  The default varies by
operating system.

Default value: `$sendmail::params::auxiliary_packages`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

Configure whether the Sendmail package should be
installed, and what version.  Valid options: `present`, `latest`, or
a specific version number.

Default value: `'present'`

##### <a name="package_manage"></a>`package_manage`

Data type: `Boolean`

Configure whether Puppet should manage the Sendmail
package(s).  Valid options: `true` or `false`.

Default value: `$sendmail::params::package_manage`

##### <a name="service_name"></a>`service_name`

Data type: `String`

The service name to use on this operating system.

Default value: `$sendmail::params::service_name`

##### <a name="service_enable"></a>`service_enable`

Data type: `Boolean`

Configure whether the Sendmail MTA should be enabled
at boot.  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="service_manage"></a>`service_manage`

Data type: `Boolean`

Configure whether Puppet should manage the Sendmail
service.  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

Configure whether the Sendmail service should be
running.  Valid options: `running` or `stopped`.

Default value: `'running'`

##### <a name="service_hasstatus"></a>`service_hasstatus`

Data type: `Boolean`

Define whether the service type can rely on
a functional status.  Valid options: `true` or `false`.

Default value: ``true``

### <a name="sendmailaccess"></a>`sendmail::access`

The class manages the file either as a single file resource or each entry
in the file separately.  The file is managed as a whole using the `source`
or `content` parameters.  The `entries` parameter is used to manage each
entry separately. Preferable this is done with hiera using automatic
parameter lookup.

This class is only used to manage the access db file. You will also need to
enable the `access_db` feature using `sendmail::mc::feature` to tell
Sendmail to actually use the file.

#### Examples

##### Manage the access database using hiera

```puppet
class { 'sendmail::access': }
```

##### Manage the access database using the given file

```puppet
class { 'sendmail::access':
  source => 'puppet:///modules/sendmail/access',
}
```

#### Parameters

The following parameters are available in the `sendmail::access` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the access file.  This allows
managing the access file as a whole.  Changes to the file automatically
triggers a rebuild of the access database file.  This attribute is
mutually exclusive with `source` and `entries`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the access file.  This allows managing the
access file as a whole.  Changes to the file automatically triggers
a rebuild of the access database file.  This attribute is mutually
exclusive with `content` and `entries`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create `sendmail::access::entry`
resources.  The class can be used to create access entries defined in
hiera.  The hiera hash should look like this:

```yaml
sendmail::access::entries:
  'example.com':
    value: 'OK'
  'example.org':
    value: 'REJECT'
```

Default value: `{}`

### <a name="sendmailaccessfile"></a>`sendmail::access::file`

Manage the Sendmail access db file.

#### Examples

##### 

```puppet
class { 'sendmail::access::file': }
```

#### Parameters

The following parameters are available in the `sendmail::access::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

### <a name="sendmailaliases"></a>`sendmail::aliases`

The class manages the file either as a single file resource or each entry
in the file separately.  The file is managed as a whole using the `source`
or `content` parameters.  The `entries` parameter is used to manage each
entry separately. Preferable this is done with hiera using automatic
parameter lookup.

#### Examples

##### Set up aliases using a configuration from hiera

```puppet
class { 'sendmail::aliases': }
```

##### Set up aliases using the given file

```puppet
class { 'sendmail::aliases':
  source => 'puppet:///modules/sendmail/aliases',
}
```

#### Parameters

The following parameters are available in the `sendmail::aliases` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the aliases file.  This allows
managing the aliases file as a whole.  Changes to the file automatically
triggers a rebuild of the aliases database file.  This attribute is
mutually exclusive with `source` and `entries`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the aliases file.  This allows managing the
aliases file as a whole.  Changes to the file automatically triggers
a rebuild of the aliases database file.  This attribute is mutually
exclusive with `content` and `entries`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create sendmail::aliases::entry
resources.  This attribute is mutually exclusive with `content` and
`source`. The class can be used to create aliases defined in hiera.
The hiera hash should look like this:

```yaml
sendmail::aliases::entries:
  'fred':
    recipient: 'barney@example.org'
```

Default value: `{}`

### <a name="sendmailaliasesfile"></a>`sendmail::aliases::file`

Create the Sendmail aliases file.

#### Examples

##### 

```puppet
class { 'sendmail::aliases::file': }
```

#### Parameters

The following parameters are available in the `sendmail::aliases::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

### <a name="sendmailauthinfo"></a>`sendmail::authinfo`

Manage the Sendmail authinfo db file.

#### Examples

##### 

```puppet
class { 'sendmail::authinfo': }

class { 'sendmail::authinfo':
  source => 'puppet:///modules/sendmail/authinfo',
}
```

#### Parameters

The following parameters are available in the `sendmail::authinfo` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the authinfo file.  This allows
managing the authinfo file as a whole.  Changes to the file automatically
triggers a rebuild of the authinfo database file.  This attribute is
mutually exclusive with `source`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the authinfo file.  This allows managing
the authinfo file as a whole.  Changes to the file automatically triggers
a rebuild of the authinfo database file.  This attribute is mutually
exclusive with `content`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create sendmail::authinfo::entry
resources.  This class can be used to create authinfo entries defined in
hiera.  The hiera hash should look like this:

```yaml
sendmail::authinfo::entries:
  'AuthInfo:example.com':
    value: '"U=auth" "P=secret"'
  'AuthInfo:192.168.67.89':
    value: '"U=fred" "P=wilma"'
```

Default value: `{}`

### <a name="sendmailauthinfofile"></a>`sendmail::authinfo::file`

Create the Sendmail authinfo db file.

#### Examples

##### 

```puppet
class { 'sendmail::authinfo::file': }
```

#### Parameters

The following parameters are available in the `sendmail::authinfo::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

### <a name="sendmaildomaintable"></a>`sendmail::domaintable`

The class manages the file either as a single file resource or each entry
in the file separately.  The file is managed as a whole using the `source`
or `content` parameters.  The `entries` parameter is used to manage each
entry separately. Preferable this is done with hiera using automatic
parameter lookup.

#### Examples

##### Manage the domaintable using hiera

```puppet
class { 'sendmail::domaintable': }
```

##### Manage the domaintable using the given file

```puppet
class { 'sendmail::domaintable':
  source => 'puppet:///modules/sendmail/domaintable',
}
```

#### Parameters

The following parameters are available in the `sendmail::domaintable` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the domaintable file.  This allows
managing the domaintable file as a whole.  Changes to the file
automatically triggers a rebuild of the domaintable database file.  This
attribute is mutually exclusive with `source` and `entries`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the domaintable file.  This allows managing
the domaintable file as a whole.  Changes to the file automatically
triggers a rebuild of the domaintable database file.  This attribute is
mutually exclusive with `content` and `entries`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create
`sendmail::domaintable::entry` resources.  This class can be used to
create domaintable entries defined in hiera.  The hiera hash should look
like this:

```yaml
sendmail::domaintable::entries:
  'example.com':
    value: 'example.org'
  'example.net':
    value: 'example.org'
```

Default value: `{}`

### <a name="sendmaildomaintablefile"></a>`sendmail::domaintable::file`

Manage the Sendmail domaintable db file.

#### Examples

##### 

```puppet
class { 'sendmail::domaintable::file': }
```

#### Parameters

The following parameters are available in the `sendmail::domaintable::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

### <a name="sendmailgenericstable"></a>`sendmail::genericstable`

The class manages the file either as a single file resource or each entry
in the file separately.  The file is managed as a whole using the `source`
or `content` parameters.  The `entries` parameter is used to manage each
entry separately. Preferable this is done with hiera using automatic
parameter lookup.

Use the `sendmail::mc::generics_domain` type to configure the domains for
which non-local user addresses should be rewritten.

#### Examples

##### Manage the generictable using hiera

```puppet
class { 'sendmail::genericstable': }
```

##### Manage the generictable using the provided file

```puppet
class { 'sendmail::genericstable':
  source => 'puppet:///modules/sendmail/genericstable',
}
```

#### Parameters

The following parameters are available in the `sendmail::genericstable` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the genericstable file.  This allows
managing the genericstable file as a whole.  Changes to the file
automatically triggers a rebuild of the genericstable database file.
This attribute is mutually exclusive with `source` and `entries`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the genericstable file.  This allows
managing the genericstable file as a whole.  Changes to the file
automatically triggers a rebuild of the genericstable database file.
This attribute is mutually exclusive with `content` and `entries`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create
`sendmail::genericstable::entry` resources.  This class can be used to
create genericstable entries defined in hiera.  The hiera hash should
look like this:

```yaml
sendmail::genericstable::entries:
  'fred@example.com':
    value: 'fred@example.org'
  'barney':
    value: 'barney@example.org'
```

Default value: `{}`

### <a name="sendmailgenericstablefile"></a>`sendmail::genericstable::file`

Manage the Sendmail genericstable db file.

#### Examples

##### 

```puppet
class { 'sendmail::genericstable::file': }
```

#### Parameters

The following parameters are available in the `sendmail::genericstable::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

### <a name="sendmailmailertable"></a>`sendmail::mailertable`

The class manages the file either as a single file resource or each entry
in the file separately.  The file is managed as a whole using the `source`
or `content` parameters.  The `entries` parameter is used to manage each
entry separately. Preferable this is done with hiera using automatic
parameter lookup.

#### Examples

##### Manage the mailertable using hiera

```puppet
class { 'sendmail::mailertable': }
```

##### Manage the mailertable using the provided file

```puppet
class { 'sendmail::mailertable':
  source => 'puppet:///modules/sendmail/mailertable',
}
```

#### Parameters

The following parameters are available in the `sendmail::mailertable` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the mailertable file.  This allows
managing the mailertable file as a whole.  Changes to the file
automatically triggers a rebuild of the mailertable database file.  This
attribute is mutually exclusive with `source` and `entries`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the mailertable file.  This allows managing
the mailertable file as a whole.  Changes to the file automatically
triggers a rebuild of the mailertable database file.  This attribute is
mutually exclusive with `content` and `entries`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create
`sendmail::mailertable::entry` resources.  This class can be used to
create mailertable entries defined in hiera.  The hiera hash should look
like this:

```yaml
sendmail::mailertable::entries:
  '.example.com':
    value: 'smtp:relay.example.com'
  'www.example.org':
    value: 'relay:relay.example.com'
  '.example.net':
    value: 'error:5.7.0:550 mail is not accepted'
```

Default value: `{}`

### <a name="sendmailmailertablefile"></a>`sendmail::mailertable::file`

Manage the Sendmail mailertable db file.

#### Examples

##### 

```puppet
class { 'sendmail::mailertable::file': }
```

#### Parameters

The following parameters are available in the `sendmail::mailertable::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

### <a name="sendmailmakeall"></a>`sendmail::makeall`

Rebuild all config files for the Sendmail MTA using a Makefile

### <a name="sendmailmcprivacy_flags"></a>`sendmail::mc::privacy_flags`

Each option is enabled by setting the associated boolean parameter to
`true`. See the Sendmail documentation for the meaning of the flags.

#### Examples

##### Enable two specific privacy flags

```puppet
class { 'sendmail::mc::privacy_flags':
  goaway => true,
  noetrn => true,
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::privacy_flags` class:

* [`authwarnings`](#authwarnings)
* [`goaway`](#goaway)
* [`needexpnhelo`](#needexpnhelo)
* [`needmailhelo`](#needmailhelo)
* [`needvrfyhelo`](#needvrfyhelo)
* [`noactualrecipient`](#noactualrecipient)
* [`nobodyreturn`](#nobodyreturn)
* [`noetrn`](#noetrn)
* [`noexpn`](#noexpn)
* [`noreceipts`](#noreceipts)
* [`noverb`](#noverb)
* [`novrfy`](#novrfy)
* [`public`](#public)
* [`restrictexpand`](#restrictexpand)
* [`restrictmailq`](#restrictmailq)
* [`restrictqrun`](#restrictqrun)

##### <a name="authwarnings"></a>`authwarnings`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="goaway"></a>`goaway`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="needexpnhelo"></a>`needexpnhelo`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="needmailhelo"></a>`needmailhelo`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="needvrfyhelo"></a>`needvrfyhelo`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="noactualrecipient"></a>`noactualrecipient`

Data type: `Boolean`

Whether the privacy option of the same name should
be enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="nobodyreturn"></a>`nobodyreturn`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="noetrn"></a>`noetrn`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="noexpn"></a>`noexpn`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="noreceipts"></a>`noreceipts`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="noverb"></a>`noverb`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="novrfy"></a>`novrfy`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="public"></a>`public`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="restrictexpand"></a>`restrictexpand`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="restrictmailq"></a>`restrictmailq`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="restrictqrun"></a>`restrictqrun`

Data type: `Boolean`

Whether the privacy option of the same name should be
enabled.  Valid options: `true` or `false`.

Default value: ``false``

### <a name="sendmailmctimeouts"></a>`sendmail::mc::timeouts`

This class allows setting various timeouts for Sendmail without having to
use the `sendmail::mc::define` macro individually for each entry.

#### Examples

##### Disable RFC1413 ident requests

```puppet
class { 'sendmail::mc::timeouts':
  ident => '0',
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::timeouts` class:

* [`aconnect`](#aconnect)
* [`auth`](#auth)
* [`command`](#command)
* [`connect`](#connect)
* [`control`](#control)
* [`datablock`](#datablock)
* [`datafinal`](#datafinal)
* [`datainit`](#datainit)
* [`fileopen`](#fileopen)
* [`helo`](#helo)
* [`hoststatus`](#hoststatus)
* [`iconnect`](#iconnect)
* [`ident`](#ident)
* [`initial`](#initial)
* [`lhlo`](#lhlo)
* [`mail`](#mail)
* [`misc`](#misc)
* [`quit`](#quit)
* [`rcpt`](#rcpt)
* [`rset`](#rset)
* [`starttls`](#starttls)

##### <a name="aconnect"></a>`aconnect`

Data type: `Optional[String]`

Timeout for all connection attempts when trying to reach
one or multiple hosts for sending a single mail.

Default value: ``undef``

##### <a name="auth"></a>`auth`

Data type: `Optional[String]`

Timeout when waiting for AUTH negotiation.

Default value: ``undef``

##### <a name="command"></a>`command`

Data type: `Optional[String]`

Timeout when waiting for the next SMTP command.

Default value: ``undef``

##### <a name="connect"></a>`connect`

Data type: `Optional[String]`

Timeout for one connection attempt when trying to establish
a network connection.  Also see then `iconnect` parameter.

Default value: ``undef``

##### <a name="control"></a>`control`

Data type: `Optional[String]`

Timout when waiting for a command on the control socket.

Default value: ``undef``

##### <a name="datablock"></a>`datablock`

Data type: `Optional[String]`

Timeout when waiting on a read operation during the DATA
phase.

Default value: ``undef``

##### <a name="datafinal"></a>`datafinal`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment after sending
the final dot in the DATA phase.

Default value: ``undef``

##### <a name="datainit"></a>`datainit`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment of the DATA
command.

Default value: ``undef``

##### <a name="fileopen"></a>`fileopen`

Data type: `Optional[String]`

Timeout when waiting for access to a local file.

Default value: ``undef``

##### <a name="helo"></a>`helo`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment of the HELO or EHLO
commands.

Default value: ``undef``

##### <a name="hoststatus"></a>`hoststatus`

Data type: `Optional[String]`

Timeout for invalidation of hoststatus information during
a single queue run.

Default value: ``undef``

##### <a name="iconnect"></a>`iconnect`

Data type: `Optional[String]`

Timeout for the first connection attempt to a host when
trying to establish a network connection.  Also see then `connect`
parameter.

Default value: ``undef``

##### <a name="ident"></a>`ident`

Data type: `Optional[String]`

Timeout when waiting to a response to a RFC1413 identification
protocol query.  Set this to `0` to disable the identification protocol.

Default value: ``undef``

##### <a name="initial"></a>`initial`

Data type: `Optional[String]`

Timeout when waiting for the initial greeting message.

Default value: ``undef``

##### <a name="lhlo"></a>`lhlo`

Data type: `Optional[String]`

Timeout when waiting for the reply to the initial LHLO command
on an LMTP connection.

Default value: ``undef``

##### <a name="mail"></a>`mail`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment of the MAIL
command.

Default value: ``undef``

##### <a name="misc"></a>`misc`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment of various other
commands (VERB, NOOP, ...).

Default value: ``undef``

##### <a name="quit"></a>`quit`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment of the QUIT
command.

Default value: ``undef``

##### <a name="rcpt"></a>`rcpt`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment of the RCPT
command.

Default value: ``undef``

##### <a name="rset"></a>`rset`

Data type: `Optional[String]`

Timeout when waiting for the acknowledgment of the RSET
command.

Default value: ``undef``

##### <a name="starttls"></a>`starttls`

Data type: `Optional[String]`

Timeout when waiting for STARTTLS negotiation.

Default value: ``undef``

### <a name="sendmailmctrust_auth_mech"></a>`sendmail::mc::trust_auth_mech`

Add the `TRUST_AUTH_MECH` macro to the sendmail.mc file.

#### Examples

##### Activate `PLAIN` authentication

```puppet
class { 'sendmail::mc::trust_auth_mech':
  trust_auth_mech => 'PLAIN',
}
```

##### Activate `PLAIN` and `DIGEST-MD5` authentication

```puppet
class { 'sendmail::mc::trust_auth_mech':
  trust_auth_mech => [ 'PLAIN', 'DIGEST-MD5', ],
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::trust_auth_mech` class:

* [`trust_auth_mech`](#trust_auth_mech)

##### <a name="trust_auth_mech"></a>`trust_auth_mech`

Data type: `Variant[String,Array[String]]`

The value of the `TRUST_AUTH_MECH` macro to set.  If
this is a string it is used as-is.  For an array the value will be
concatenated into a string.

### <a name="sendmailnullclient"></a>`sendmail::nullclient`

No mail can be received from the outside since the Sendmail daemon only
listens on the localhost address `127.0.0.1`. All local mail is forwarded
to a given mail hub.

This is a convenience class to make the configuration simple. Internally it
declares the `sendmail` class using appropriate parameters. Normally no
other configuration should be necessary.

#### Examples

##### Create a nullclient config forwarding to a given hub

```puppet
class { 'sendmail::nullclient':
  mail_hub => '[192.168.1.1]',
}
```

#### Parameters

The following parameters are available in the `sendmail::nullclient` class:

* [`mail_hub`](#mail_hub)
* [`port`](#port)
* [`port_option_modify`](#port_option_modify)
* [`enable_ipv4_msa`](#enable_ipv4_msa)
* [`enable_ipv6_msa`](#enable_ipv6_msa)
* [`enable_msp_trusted_users`](#enable_msp_trusted_users)
* [`trusted_users`](#trusted_users)
* [`domain_name`](#domain_name)
* [`max_message_size`](#max_message_size)
* [`log_level`](#log_level)
* [`ca_cert_file`](#ca_cert_file)
* [`ca_cert_path`](#ca_cert_path)
* [`server_cert_file`](#server_cert_file)
* [`server_key_file`](#server_key_file)
* [`client_cert_file`](#client_cert_file)
* [`client_key_file`](#client_key_file)
* [`crl_file`](#crl_file)
* [`dh_params`](#dh_params)
* [`tls_srv_options`](#tls_srv_options)
* [`cipher_list`](#cipher_list)
* [`server_ssl_options`](#server_ssl_options)
* [`client_ssl_options`](#client_ssl_options)

##### <a name="mail_hub"></a>`mail_hub`

Data type: `String`

The hostname or IP address of the mail hub where all mail
is forwarded to.  It can be enclosed in brackets to prevent MX lookups.

##### <a name="port"></a>`port`

Data type: `Pattern[/^[0-9]+$/]`

The port used for the local message submission agent.

Default value: `'587'`

##### <a name="port_option_modify"></a>`port_option_modify`

Data type: `Optional[Pattern[/^[abcfhruACEOS]*$/]]`

Port option modifiers for the local message
submission agent.  The parameter is used to set the
`daemon_port_options`.  A useful value for the nullclient configuration
might be `S` to prevent offering STARTTLS on the MSA port.

Default value: ``undef``

##### <a name="enable_ipv4_msa"></a>`enable_ipv4_msa`

Data type: `Boolean`

Enable the local message submission agent on the
IPv4 loopback address (`127.0.0.1`).  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="enable_ipv6_msa"></a>`enable_ipv6_msa`

Data type: `Boolean`

Enable the local message submission agent on the
IPv6 loopback address (`::1`).  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="enable_msp_trusted_users"></a>`enable_msp_trusted_users`

Data type: `Boolean`

Whether the trusted users file feature is
enabled for the message submission program.  This may be necessary if you
want to allow certain users to change the sender address using `sendmail
-f`.  Valid options: `true` or `false`.

Default value: ``false``

##### <a name="trusted_users"></a>`trusted_users`

Data type: `Array[String]`

An array of user names that will be written into the
trusted users file.  Leading or trailing whitespace is ignored.  Empty
entries are also ignored.

Default value: `[]`

##### <a name="domain_name"></a>`domain_name`

Data type: `Optional[String]`

Sets the official canonical name of the local machine.
Normally this parameter is not required as Sendmail uses the fully
qualified domain name by default.  Setting this parameter will override
the value of the `$j` macro in the sendmail.cf file.

Default value: ``undef``

##### <a name="max_message_size"></a>`max_message_size`

Data type: `Optional[Sendmail::Messagesize]`

Define the maximum message size that will be
accepted.  This can be a pure numerical value given in bytes
(e.g. 33554432) or a number with a prefixed byte unit (e.g. 32MB).  The
conversion is done using the 1024 convention (see the `to_bytes` function
in the `stdlib` module), so valid prefixes are either `k` for 1024 bytes
or `M` for 1048576 bytes.

Default value: ``undef``

##### <a name="log_level"></a>`log_level`

Data type: `Optional[Sendmail::Loglevel]`

The loglevel for the sendmail process.  Valid options:
a numeric value.

Default value: ``undef``

##### <a name="ca_cert_file"></a>`ca_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL CA certificate.

Default value: ``undef``

##### <a name="ca_cert_path"></a>`ca_cert_path`

Data type: `Optional[Stdlib::Absolutepath]`

The directory where SSL CA certificates are kept.

Default value: ``undef``

##### <a name="server_cert_file"></a>`server_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL server certificate for
inbound connections.

Default value: ``undef``

##### <a name="server_key_file"></a>`server_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL server key for inbound
connections.

Default value: ``undef``

##### <a name="client_cert_file"></a>`client_cert_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL client certificate for
outbound connections.

Default value: ``undef``

##### <a name="client_key_file"></a>`client_key_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename of the SSL client key for outbound
connections.

Default value: ``undef``

##### <a name="crl_file"></a>`crl_file`

Data type: `Optional[Stdlib::Absolutepath]`

The filename with a list of revoked certificates.

Default value: ``undef``

##### <a name="dh_params"></a>`dh_params`

Data type: `Optional[Sendmail::DHParam]`

The DH parameters used for encryption.  This can be one of
the numbers `512`, `1024`, `2048` or a filename with generated
parameters.

Default value: ``undef``

##### <a name="tls_srv_options"></a>`tls_srv_options`

Data type: `Optional[Enum['V']]`

The parameter adjusts the server TLS settings.  This
can currently be either the letter `V` or the empty string.  Setting this
parameter to `V` disables the request for a client certificate.

Default value: ``undef``

##### <a name="cipher_list"></a>`cipher_list`

Data type: `Optional[String]`

Set the available ciphers for encrypted connections.

Default value: ``undef``

##### <a name="server_ssl_options"></a>`server_ssl_options`

Data type: `Optional[String]`

Configure the SSL connection flags for inbound
connections.

Default value: ``undef``

##### <a name="client_ssl_options"></a>`client_ssl_options`

Data type: `Optional[String]`

Configure the SSL connection flags for outbound
connections.

Default value: ``undef``

### <a name="sendmailuserdb"></a>`sendmail::userdb`

The class manages the file either as a single file resource or each entry
in the file separately.  The file is managed as a whole using the `source`
or `content` parameters.  The `entries` parameter is used to manage each
entry separately. Preferable this is done with hiera using automatic
parameter lookup.

#### Examples

##### Manage the userdb using hiera

```puppet
class { 'sendmail::userdb': }
```

##### Manage the userdb using the provided file

```puppet
class { 'sendmail::userdb':
  source => 'puppet:///modules/sendmail/userdb',
}
```

#### Parameters

The following parameters are available in the `sendmail::userdb` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the userdb file.  This allows
managing the userdb file as a whole.  Changes to the file automatically
triggers a rebuild of the userdb database file.  This attribute is
mutually exclusive with `source` and `entries`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the userdb file.  This allows managing the
userdb file as a whole.  Changes to the file automatically triggers
a rebuild of the userdb database file.  This attribute is mutually
exclusive with `content` and `entries`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create `sendmail::userdb::entry`
resources.  This class can be used to create userdb entries defined in
hiera.  The hiera hash should look like this:

```yaml
sendmail::userdb::entries:
  'fred:maildrop':
    value: 'fred@example.org'
  'barney:maildrop':
    value: 'barney@example.org'
```

Default value: `{}`

### <a name="sendmailuserdbfile"></a>`sendmail::userdb::file`

Manage the Sendmail userdb file.

#### Examples

##### 

```puppet
class { 'sendmail::userdb::file': }
```

#### Parameters

The following parameters are available in the `sendmail::userdb::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

### <a name="sendmailvirtusertable"></a>`sendmail::virtusertable`

The class manages the file either as a single file resource or each entry
in the file separately.  The file is managed as a whole using the `source`
or `content` parameters.  The `entries` parameter is used to manage each
entry separately. Preferable this is done with hiera using automatic
parameter lookup.

#### Examples

##### Manage the virtusertable using hiera

```puppet
class { 'sendmail::virtusertable': }
```

##### Manage the virtusertable using the provided file

```puppet
class { 'sendmail::virtusertable':
  source => 'puppet:///modules/sendmail/virtusertable',
}
```

#### Parameters

The following parameters are available in the `sendmail::virtusertable` class:

* [`content`](#content)
* [`source`](#source)
* [`entries`](#entries)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the virtusertable file.  This allows
managing the virtusertable file as a whole.  Changes to the file
automatically triggers a rebuild of the virtusertable database file.
This attribute is mutually exclusive with `source` and `entries`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file for the virtusertable file.  This allows
managing the virtusertable file as a whole.  Changes to the file
automatically triggers a rebuild of the virtusertable database file.
This attribute is mutually exclusive with `content` and `entries`.

Default value: ``undef``

##### <a name="entries"></a>`entries`

Data type: `Hash[String,Data]`

A hash that will be used to create
`sendmail::virtusertable::entry` resources.  This class can be used to
create virtusertable entries defined in hiera.  The hiera hash should
look like this:

```yaml
sendmail::virtusertable::entries:
  'info@example.com':
    value: 'fred'
  '@example.org':
    value: 'barney'
```

Default value: `{}`

### <a name="sendmailvirtusertablefile"></a>`sendmail::virtusertable::file`

Manage the Sendmail virtusertable db file.

#### Examples

##### 

```puppet
class { 'sendmail::virtusertable::file': }
```

#### Parameters

The following parameters are available in the `sendmail::virtusertable::file` class:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content of the file resource.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the file resource.

Default value: ``undef``

## Defined types

### <a name="sendmailaccessentry"></a>`sendmail::access::entry`

The feature `access_db` must also be enabled by calling
`sendmail::mc::feature` to make Sendmail use the access db file.

#### Examples

##### Create an access entry for a domain

```puppet
sendmail::access::entry { 'example.com':
  value => 'RELAY',
}
```

#### Parameters

The following parameters are available in the `sendmail::access::entry` defined type:

* [`ensure`](#ensure)
* [`key`](#key)
* [`value`](#value)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the access db entry.  Valid options:
`present`, `absent`.

Default value: `'present'`

##### <a name="key"></a>`key`

Data type: `String`

The key used by Sendmail for the lookup.  This could for example
be a domain name.

Default value: `$name`

##### <a name="value"></a>`value`

Data type: `Optional[String]`

The value for the given key.  For the access map this is
typically something like `OK`, `REJECT` or `DISCARD`.

Default value: ``undef``

### <a name="sendmailaliasesentry"></a>`sendmail::aliases::entry`

Manage an entry in the Sendmail alias file.

#### Examples

##### Add a local alias for `fred`

```puppet
sendmail::aliases::entry { 'fred':
  recipient => 'barney@example.org',
}
```

#### Parameters

The following parameters are available in the `sendmail::aliases::entry` defined type:

* [`alias_name`](#alias_name)
* [`ensure`](#ensure)
* [`recipient`](#recipient)

##### <a name="alias_name"></a>`alias_name`

Data type: `String`

The name of the alias to create.

Default value: `$name`

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the alias entry.  Valid options:
`present`, `absent`.

Default value: `'present'`

##### <a name="recipient"></a>`recipient`

Data type: `Optional[Variant[String,Array[String]]]`

The recipient where the mail is redirected to.  This can
be a string for one recipient or an array of strings for multiple
recipients.

Default value: ``undef``

### <a name="sendmailauthinfoentry"></a>`sendmail::authinfo::entry`

Manage an entry in the Sendmail authinfo db file.

#### Examples

##### Add an authinfo entry

```puppet
sendmail::authinfo::entry { 'example.com':
  password         => 'secret',
  authorization_id => 'auth',
}
```

#### Parameters

The following parameters are available in the `sendmail::authinfo::entry` defined type:

* [`ensure`](#ensure)
* [`mechanisms`](#mechanisms)
* [`address`](#address)
* [`password`](#password)
* [`password_base64`](#password_base64)
* [`authorization_id`](#authorization_id)
* [`authentication_id`](#authentication_id)
* [`realm`](#realm)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the authinfo db entry.

Default value: `'present'`

##### <a name="mechanisms"></a>`mechanisms`

Data type: `Array[String]`

The list of preferred authentication mechanisms.

Default value: `[]`

##### <a name="address"></a>`address`

Data type: `String`

The key used by Sendmail for the database lookup.  This can
be an IPv4 address (e.g. `192.168.67.89`), an IPv6 address (e.g.
`IPv6:2001:DB18::23f4`), a hostname (e.g. `www.example.org`) or a domain
name (e.g. `example.com`).  The database key is required to start with
the literal expression `AuthInfo:`.  This prefix will be added
automatically if necessary.

Default value: `$name`

##### <a name="password"></a>`password`

Data type: `Optional[String]`

The password used for remote authentication in clear text.
Exactly one of `password` or `password_base64` must be set.

Default value: ``undef``

##### <a name="password_base64"></a>`password_base64`

Data type: `Optional[String]`

The password used for remote authentication in
Base64 encoding.  Exactly one of `password` or `password_base64` must be
set.

Default value: ``undef``

##### <a name="authorization_id"></a>`authorization_id`

Data type: `Optional[String]`

The user (authorization) identifier.  One of the
parameters `authorization_id` or `authentication_id` or both must be set.

Default value: ``undef``

##### <a name="authentication_id"></a>`authentication_id`

Data type: `Optional[String]`

The authentication identifier.  One of the
parameters `authorization_id` or `authentication_id` or both must be set.

Default value: ``undef``

##### <a name="realm"></a>`realm`

Data type: `Optional[String]`

The administrative realm to use.

Default value: ``undef``

### <a name="sendmaildomaintableentry"></a>`sendmail::domaintable::entry`

Manage an entry in the Sendmail domaintable file.

#### Examples

##### Add an entry to the domaintable

```puppet
sendmail::domaintable::entry { 'example.com':
  value => 'example.org',
}
```

#### Parameters

The following parameters are available in the `sendmail::domaintable::entry` defined type:

* [`ensure`](#ensure)
* [`key`](#key)
* [`value`](#value)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the domaintable db entry.  Valid
options: `present`, `absent`.

Default value: `'present'`

##### <a name="key"></a>`key`

Data type: `String`

The key used by Sendmail for the lookup.  This should normally
be a domain name.

Default value: `$name`

##### <a name="value"></a>`value`

Data type: `Optional[String]`

The value for the given key.  For the domaintable map this is
typically another domain name.

Default value: ``undef``

### <a name="sendmailgenericstableentry"></a>`sendmail::genericstable::entry`

Manage an entry in the Sendmail genericstable file.

#### Examples

##### Override the recipient `fred@example.com` with another address

```puppet
sendmail::genericstable::entry { 'fred@example.com':
  value => 'fred@example.org',
}
```

##### Forward local mail to `barney` to a remote address

```puppet
sendmail::genericstable::entry { 'barney':
  value => 'barney@example.org',
}
```

#### Parameters

The following parameters are available in the `sendmail::genericstable::entry` defined type:

* [`ensure`](#ensure)
* [`key`](#key)
* [`value`](#value)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the genericstable db entry.  Valid
options: `present`, `absent`.

Default value: `'present'`

##### <a name="key"></a>`key`

Data type: `String`

The key used by Sendmail for the lookup.  This is normally
a username or a user and domain name.

Default value: `$name`

##### <a name="value"></a>`value`

Data type: `Optional[String]`

The value for the given key.  For the genericstable map this
is typically something like `user@example.org`.

Default value: ``undef``

### <a name="sendmailmailertableentry"></a>`sendmail::mailertable::entry`

Manage an entry in the Sendmail mailertable file.

#### Examples

##### Forward all mail for the `example.com` domain to a given relay

```puppet
sendmail::mailertable::entry { '.example.com':
  value => 'smtp:relay.example.com',
}
```

##### Reject all mail for the `example.net` domain with a given error

```puppet
sendmail::mailertable::entry { '.example.net':
  value => 'error:5.7.0:550 mail is not accepted',
}
```

#### Parameters

The following parameters are available in the `sendmail::mailertable::entry` defined type:

* [`ensure`](#ensure)
* [`key`](#key)
* [`value`](#value)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the mailertable db entry.  Valid
options: `present`, `absent`.

Default value: `'present'`

##### <a name="key"></a>`key`

Data type: `String`

The key used by Sendmail for the lookup.  This should either be
a fully qualified host name or a domain name with a leading dot.

Default value: `$name`

##### <a name="value"></a>`value`

Data type: `Optional[String]`

The value for the given key.  For the mailertable map this is
typically something like `smtp:hostname`.  The error mailer can be used
to configure specific errors for certain hosts.

Default value: ``undef``

### <a name="sendmailmcdaemon_options"></a>`sendmail::mc::daemon_options`

Add the `DAEMON_OPTIONS` macro to the sendmail.mc file.

#### Examples

##### Define a MTA daemon for port 25 using IPv4

```puppet
sendmail::mc::daemon_options { 'MTA-v4':
  daemon_name => 'MTA',
  family      => 'inet',
  port        => '25',
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::daemon_options` defined type:

* [`daemon_name`](#daemon_name)
* [`family`](#family)
* [`addr`](#addr)
* [`port`](#port)
* [`children`](#children)
* [`delivery_mode`](#delivery_mode)
* [`input_filter`](#input_filter)
* [`listen`](#listen)
* [`modify`](#modify)
* [`delay_la`](#delay_la)
* [`queue_la`](#queue_la)
* [`refuse_la`](#refuse_la)
* [`send_buf_size`](#send_buf_size)
* [`receive_buf_size`](#receive_buf_size)

##### <a name="daemon_name"></a>`daemon_name`

Data type: `String`

The name of the daemon to use.  The logfile will contain
this name to identify the daemon.

Default value: `$name`

##### <a name="family"></a>`family`

Data type: `Optional[Enum['inet', 'inet6', 'iso']]`

The network family type.  Valid options: `inet`, `inet6` or
`iso`.

Default value: ``undef``

##### <a name="addr"></a>`addr`

Data type: `Optional[String]`

The network address to listen on for remote connections.  This
can be a hostname or network address.

Default value: ``undef``

##### <a name="port"></a>`port`

Data type: `Optional[String]`

The port used by the daemon.  This can be either a numeric port
number or a service name like `smtp` for port 25 or `submission`for port
587.

Default value: ``undef``

##### <a name="children"></a>`children`

Data type: `Optional[String]`

The maximum number of processes to fork for this daemon.

Default value: ``undef``

##### <a name="delivery_mode"></a>`delivery_mode`

Data type: `Optional[Sendmail::Deliverymode]`

The mode of delivery for this daemon.  Valid options:
`background`, `deferred`, `interactive` or `queueonly`.

Default value: ``undef``

##### <a name="input_filter"></a>`input_filter`

Data type: `Optional[Variant[String,Array[String]]]`

A list of milters to use.  This can either be an array
of milter names or a single string, where the milter names are separated
by colons.

Default value: ``undef``

##### <a name="listen"></a>`listen`

Data type: `Optional[String]`

The length of the listen queue used by the operating system.

Default value: ``undef``

##### <a name="modify"></a>`modify`

Data type: `Optional[String]`

Single letter flags to modify the daemon behaviour.  See the
Sendmail documention for details.

Default value: ``undef``

##### <a name="delay_la"></a>`delay_la`

Data type: `Optional[String]`

The local load average at which connections are delayed
before they are accepted.

Default value: ``undef``

##### <a name="queue_la"></a>`queue_la`

Data type: `Optional[String]`

The local load average at which received mail is queued and
not delivered immediately.

Default value: ``undef``

##### <a name="refuse_la"></a>`refuse_la`

Data type: `Optional[String]`

The local load average at which mail is no longer
accepted.

Default value: ``undef``

##### <a name="send_buf_size"></a>`send_buf_size`

Data type: `Optional[String]`

The size of the network send buffer used by the
operating system.  The value is a size in bytes.

Default value: ``undef``

##### <a name="receive_buf_size"></a>`receive_buf_size`

Data type: `Optional[String]`

The size of the network receive buffer used by the
operating system.  The value is a size in bytes.

Default value: ``undef``

### <a name="sendmailmcdefine"></a>`sendmail::mc::define`

Add m4 macro defines to the sendmail.mc file.

#### Examples

##### Set a configuration item using m4 quotes

```puppet
sendmail::mc::define { 'confFOO':
  expansion  => 'foo',
}
```

##### Set a configuration item without m4 quotes

```puppet
sendmail::mc::define { 'confBAR':
  expansion  => 'foo',
  use_quotes => false,
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::define` defined type:

* [`expansion`](#expansion)
* [`use_quotes`](#use_quotes)
* [`macro_name`](#macro_name)

##### <a name="expansion"></a>`expansion`

Data type: `Optional[Variant[String,Integer]]`

The expansion defined for the macro.

Default value: ``undef``

##### <a name="use_quotes"></a>`use_quotes`

Data type: `Boolean`

A boolean that indicates if the expansion should be
quoted (using m4 quotes).  Valid options: `true` or `false`.

Default value: ``true``

##### <a name="macro_name"></a>`macro_name`

Data type: `String`

The name of the macro that will be defined.  This will be
the first argument of the m4 define builtin.  **Note**: The macro name
should not be quoted as it will always be quoted in the template.

Default value: `$name`

### <a name="sendmailmcdomain"></a>`sendmail::mc::domain`

Add the `DOMAIN` macro to the sendmail.mc file.

#### Examples

##### Include settings for the `generic` domain

```puppet
sendmail::mc::domain { 'generic': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::domain` defined type:

* [`domain_name`](#domain_name)

##### <a name="domain_name"></a>`domain_name`

Data type: `String`

The name of the sendmail domain file as a string.  The
value is used as argument to the `DOMAIN` macro in the generated
sendmail.mc file.  This will include the m4 file with domain specific
settings.

Default value: `$title`

### <a name="sendmailmcenhdnsbl"></a>`sendmail::mc::enhdnsbl`

Manage enhanced DNS blacklist entries

#### Examples

##### Include the DNS blacklist `dialups.mail-abuse.org`

```puppet
sendmail::mc::enhdnsbl { 'dialups.mail-abuse.org':
  reject_message          => '"550 dial-up site refused"',
  allow_temporary_failure => true,
  lookup_result           => '127.0.0.3.',
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::enhdnsbl` defined type:

* [`blacklist`](#blacklist)
* [`allow_temporary_failure`](#allow_temporary_failure)
* [`reject_message`](#reject_message)
* [`lookup_result`](#lookup_result)

##### <a name="blacklist"></a>`blacklist`

Data type: `String`

The DNS name to query the blacklist.

Default value: `$name`

##### <a name="allow_temporary_failure"></a>`allow_temporary_failure`

Data type: `Boolean`

Determine what happens when a temporary
failure of the DNS lookup occurs.  The message is accepted when this
parameter is set to `false`.  A temporary error is signaled when this is
set to `true`.

Default value: ``false``

##### <a name="reject_message"></a>`reject_message`

Data type: `Optional[String]`

The error message used when rejecting a message.

Default value: ``undef``

##### <a name="lookup_result"></a>`lookup_result`

Data type: `Optional[String]`

Check the DNS lookup for this result.  Leave this
parameter unset to block the message as long as anything is returned from
the lookup.

Default value: ``undef``

### <a name="sendmailmcfeature"></a>`sendmail::mc::feature`

Add the `FEATURE` macro to the sendmail.mc file.

#### Examples

##### Enable the `mailertable` feature

```puppet
sendmail::mc::feature { 'mailertable': }
```

##### Enable the `mailertable` feature using the given file location

```puppet
sendmail::mc::feature { 'mailertable':
  args => [ 'hash /etc/mail/mailertable' ],
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::feature` defined type:

* [`feature_name`](#feature_name)
* [`args`](#args)
* [`use_quotes`](#use_quotes)

##### <a name="feature_name"></a>`feature_name`

Data type: `String`

The name of the feature that will be used.  This will
be the first argument of the `FEATURE()`.  **Note**: The feature name
should not be quoted as it will always be quoted in the template.

Default value: `$name`

##### <a name="args"></a>`args`

Data type: `Variant[String,Array[String]]`

The arguments used for the feature.  This can be a string (one
argument) or and an array and it will be used for the following arguments
of the `FEATURE()`.

Default value: `[]`

##### <a name="use_quotes"></a>`use_quotes`

Data type: `Boolean`

A boolean that indicates if the arguments should be
quoted (using m4 quotes).  Valid options: `true` or `false`.

Default value: ``true``

### <a name="sendmailmcgenerics_domain"></a>`sendmail::mc::generics_domain`

Add the `GENERICS_DOMAIN` macro to the sendmail.mc file.

#### Examples

##### Enable genericstable processing for the domain `example.net`

```puppet
sendmail::mc::generics_domain { 'example.net': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::generics_domain` defined type:

* [`domain_name`](#domain_name)

##### <a name="domain_name"></a>`domain_name`

Data type: `String`

The name of the domain for which the genericstable is
enabled.

Default value: `$name`

### <a name="sendmailmcinclude"></a>`sendmail::mc::include`

Add include fragments to the sendmail.mc file.

#### Examples

##### Include a milter setup file to the configuration

```puppet
sendmail::mc::include { '/etc/mail/m4/clamav-milter.m4': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::include` defined type:

* [`filename`](#filename)
* [`order`](#order)

##### <a name="filename"></a>`filename`

Data type: `Stdlib::Absolutepath`

The absolute path of the file to include.

Default value: `$name`

##### <a name="order"></a>`order`

Data type: `String`

The position in the sendmail.mc file where the include
statement will appear.  This requires internal knowledge of the sendmail
module.  See the Puppet class `sendmail::mc` for details.  The default
generates the include statements just before the `MAILER` section.

Default value: `'59'`

### <a name="sendmailmcldaproute_domain"></a>`sendmail::mc::ldaproute_domain`

Add the `LDAPROUTE_DOMAIN` macro to the sendmail.mc file.

#### Examples

##### Enable LDAP routing for `example.net`

```puppet
sendmail::mc::ldaproute_domain { 'example.net': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::ldaproute_domain` defined type:

* [`domain_name`](#domain_name)

##### <a name="domain_name"></a>`domain_name`

Data type: `String`

The name of the domain for which LDAP routing is
enabled.

Default value: `$name`

### <a name="sendmailmclocal_config"></a>`sendmail::mc::local_config`

Add a `LOCAL_CONFIG` section into the sendmail.mc file.

#### Examples

##### Add the X-AuthUser header to each mail

```puppet
sendmail::mc::local_config { 'X-AuthUser':
  content => 'HX-AuthUser: ${auth_authen}',
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::local_config` defined type:

* [`content`](#content)
* [`source`](#source)

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The desired contents of the local config section.  This
attribute is mutually exclusive with `source`.

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

A source file included as the local config section.  This
attribute is mutually exclusive with `content`.

Default value: ``undef``

### <a name="sendmailmcmailer"></a>`sendmail::mc::mailer`

Add a `MAILER` macro to the sendmail.mc file.

#### Examples

##### Add the local mailer to the configuration

```puppet
sendmail::mc::mailer { 'local': }
```

##### Add the SMTP mailer to the configuration

```puppet
sendmail::mc::mailer { 'smtp': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::mailer` defined type:

* [`mailer`](#mailer)

##### <a name="mailer"></a>`mailer`

Data type: `String`

The name of the mailer to add to the configuration.  The
position of the mailer in the configuration file is determined according
to the Bat Book.

Default value: `$name`

### <a name="sendmailmcmasquerade_as"></a>`sendmail::mc::masquerade_as`

Add the `MASQUERADE_AS` macro to the sendmail.mc file.

#### Examples

##### Masquerade as `example.com` including envelope adresses

```puppet
sendmail::mc::masquerade_as { 'example.com':
  masquerade_envelope => true,
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::masquerade_as` defined type:

* [`masquerade_as`](#masquerade_as)
* [`masquerade_domain`](#masquerade_domain)
* [`masquerade_domain_file`](#masquerade_domain_file)
* [`masquerade_exception`](#masquerade_exception)
* [`masquerade_exception_file`](#masquerade_exception_file)
* [`masquerade_envelope`](#masquerade_envelope)
* [`allmasquerade`](#allmasquerade)
* [`limited_masquerade`](#limited_masquerade)
* [`local_no_masquerade`](#local_no_masquerade)
* [`masquerade_entire_domain`](#masquerade_entire_domain)
* [`exposed_user`](#exposed_user)
* [`exposed_user_file`](#exposed_user_file)

##### <a name="masquerade_as"></a>`masquerade_as`

Data type: `String`

Mail being sent is rewritten as coming from the
indicated address.

Default value: `$name`

##### <a name="masquerade_domain"></a>`masquerade_domain`

Data type: `Array[String]`

Normally masquerading only rewrites mail from the
local host.  This parameter sets a set of domain or host names that is
used for masquerading.

Default value: `[]`

##### <a name="masquerade_domain_file"></a>`masquerade_domain_file`

Data type: `Optional[Stdlib::Absolutepath]`

The set of domain or host names to be used
for masquerading can also be read from the file given here.

Default value: ``undef``

##### <a name="masquerade_exception"></a>`masquerade_exception`

Data type: `Array[String]`

This parameter can set exceptions if not all
hosts or subdomains for a given domain should be rewritten.

Default value: `[]`

##### <a name="masquerade_exception_file"></a>`masquerade_exception_file`

Data type: `Optional[Stdlib::Absolutepath]`

The exceptions can also be read from the
file given here.

Default value: ``undef``

##### <a name="masquerade_envelope"></a>`masquerade_envelope`

Data type: `Boolean`

Normally only header addresses are used for
masquerading.  By setting this parameter to `true`, also envelope
addresses are rewritten.

Default value: ``false``

##### <a name="allmasquerade"></a>`allmasquerade`

Data type: `Boolean`

Enable the `allmasquerade` feature if set to
`true`.

Default value: ``false``

##### <a name="limited_masquerade"></a>`limited_masquerade`

Data type: `Boolean`

Enable the `limited_masquerade` feature if set to
`true`.

Default value: ``false``

##### <a name="local_no_masquerade"></a>`local_no_masquerade`

Data type: `Boolean`

Enable the `local_no_masquerade` feature if set
to `true`.

Default value: ``false``

##### <a name="masquerade_entire_domain"></a>`masquerade_entire_domain`

Data type: `Boolean`

Enable the `masquerade_entire_domain`
feature if set to `true`.

Default value: ``false``

##### <a name="exposed_user"></a>`exposed_user`

Data type: `Array[String]`

An array of usernames that should not be masqueraded.
This may be useful for system users (`root` has been exposed by default
prior to Sendmail 8.10).

Default value: `[]`

##### <a name="exposed_user_file"></a>`exposed_user_file`

Data type: `Optional[Stdlib::Absolutepath]`

The usernames that should not be masqueraded can
also be read from the file given here.

Default value: ``undef``

### <a name="sendmailmcmilter"></a>`sendmail::mc::milter`

Manage Sendmail Milter configuration in sendmail.mc

#### Examples

##### Add the `greylist` milter using a local socket

```puppet
sendmail::mc::milter { 'greylist':
  socket_type => 'local',
  socket_spec => '/var/run/milter-greylist/milter-greylist.sock',
}
```

##### Add the `greylist` milter using a TCP/IP socket

```puppet
sendmail::mc::milter { 'greylist':
  socket_type => 'inet',
  socket_spec => '12345@192.168.0.42',
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::milter` defined type:

* [`socket_type`](#socket_type)
* [`socket_spec`](#socket_spec)
* [`flags`](#flags)
* [`send_timeout`](#send_timeout)
* [`receive_timeout`](#receive_timeout)
* [`eom_timeout`](#eom_timeout)
* [`connect_timeout`](#connect_timeout)
* [`order`](#order)
* [`milter_name`](#milter_name)
* [`enable`](#enable)

##### <a name="socket_type"></a>`socket_type`

Data type: `Enum['local','unix','inet','inet6']`

The type of socket to use for connecting to the milter.
Valid values: `local`, `unix`, `inet`, `inet6`

##### <a name="socket_spec"></a>`socket_spec`

Data type: `String`

The socket specification for connecting to the milter.
For the type `local` (`unix` is a synonym) this is the full path to the
Unix-domain socket.  For the `inet` and `inet6` type socket this must be
the port number, a literal `@` character and the host or address
specification.

##### <a name="flags"></a>`flags`

Data type: `Enum['R','T','4','']`

Either the empty string or a single character to specify how
milter failures are handled by Sendmail.  The letter `R` rejects the
message, a `T` causes a temporary failure and the character `4`
(available with Sendmail V8.4 or later) rejects with a 421 response code.
If the empty string is used, Sendmail will treat a milter failure as if
the milter wasn't configured.

Default value: `'T'`

##### <a name="send_timeout"></a>`send_timeout`

Data type: `Optional[Sendmail::Timeout]`

Timeout when sending data from the MTA to the Milter.
The default is undefined (using the Sendmail default 10sec).

Default value: ``undef``

##### <a name="receive_timeout"></a>`receive_timeout`

Data type: `Optional[Sendmail::Timeout]`

Timeout when reading a reply from the Milter.  The
default is undefined (using the Sendmail default 10sec).

Default value: ``undef``

##### <a name="eom_timeout"></a>`eom_timeout`

Data type: `Optional[Sendmail::Timeout]`

Overall timeout from sending the messag to Milter until
the final end of message reply is received.  The default is undefined
(using the Sendmail default 5min).

Default value: ``undef``

##### <a name="connect_timeout"></a>`connect_timeout`

Data type: `Optional[Sendmail::Timeout]`

Connection timeout. The default value is undefined
(using the Sendmail default 5min).

Default value: ``undef``

##### <a name="order"></a>`order`

Data type: `String`

A string used to determine the order of the mail filters in
the configuration file.  This also defines the order in which the filters
are called.

Default value: `'00'`

##### <a name="milter_name"></a>`milter_name`

Data type: `String`

The name of the milter to create.

Default value: `$name`

##### <a name="enable"></a>`enable`

Data type: `Boolean`

A boolean to indicate if the milter should automatically be
enabled.  If this is `true` (the default) then the milter will be called
by Sendmail for every incoming mail.  If this is set to `false` then the
milter is only defined.  It needs to be enabled by either setting the
parameter `input_filter` for `sendmail::mc::daemon_options` or defining
`confINPUT_MAIL_FILTERS`.  Internally this parameter determines if the
`INPUT_MAIL_FILTER()` or `MAIL_FILTER()` macros are used.

Default value: ``true``

### <a name="sendmailmcmodify_mailer_flags"></a>`sendmail::mc::modify_mailer_flags`

Add a `MODIFY_MAILER_FLAGS` macro to the sendmail.mc file.

#### Examples

##### Add the `O` flag to the `SMTP` mailer

```puppet
sendmail::mc::modify_mailer_flags { 'SMTP':
  flags => '+O',
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::modify_mailer_flags` defined type:

* [`mailer_name`](#mailer_name)
* [`flags`](#flags)
* [`use_quotes`](#use_quotes)

##### <a name="mailer_name"></a>`mailer_name`

Data type: `String`

The name of the mailer for which the flags will be
changed.  This name is case-sensitive and must conform to the name of the
mailer.  Usually this will be a name in uppercase (e.g. `SMTP` or
`LOCAL`).

Default value: `$name`

##### <a name="flags"></a>`flags`

Data type: `String`

The flags to change.  Adding single flags is possible by
prefixing the flag with a `+` symbol.  Removing single flags from the
mailer can be done with a `-` symbol as prefix.  Without a leading `+` or
`-` the flags will replace the flags of the delivery agent.

##### <a name="use_quotes"></a>`use_quotes`

Data type: `Boolean`

A boolean that indicates if the flags should be quoted
(using m4 quotes).  If this argument is `true`, then the flags will be
enclosed in ` and ' symbols in the generated output file.  Valid options:
`true` or `false`.

Default value: ``true``

### <a name="sendmailmcostype"></a>`sendmail::mc::ostype`

Add the `OSTYPE` macro to the sendmail.mc file.

#### Examples

##### Set the `OSTYPE` to Debian

```puppet
sendmail::mc::ostype { 'Debian': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::ostype` defined type:

* [`ostype`](#ostype)

##### <a name="ostype"></a>`ostype`

Data type: `String`

The type of operating system as a string.  The value is used
to add the `OSTYPE` macro to the generated sendmail.mc file.  This will
include the m4 file with operating system specific settings.

Default value: `$name`

### <a name="sendmailmcqueue_group"></a>`sendmail::mc::queue_group`

Add the `QUEUE_GROUP` macro to the sendmail.mc file.

#### Examples

##### Create a queue group named `gmailcom` for single recipient delivery

```puppet
sendmail::mc::queue_group { 'gmailcom':
  flags      => 'f',
  interval   => '60m',
  path       => '/var/spool/mqueues/gmail',
  recipients => 1,
}
```

#### Parameters

The following parameters are available in the `sendmail::mc::queue_group` defined type:

* [`queue_group`](#queue_group)
* [`flags`](#flags)
* [`interval`](#interval)
* [`jobs`](#jobs)
* [`nice`](#nice)
* [`recipients`](#recipients)
* [`runners`](#runners)
* [`path`](#path)

##### <a name="queue_group"></a>`queue_group`

Data type: `String`

The name of the queue group.

Default value: `$name`

##### <a name="flags"></a>`flags`

Data type: `Optional[String]`

Flags for the queue group.  Currently only the `f` flag is
supported and causes Sendmail to create one queue process for each queue
directory in the group.

Default value: ``undef``

##### <a name="interval"></a>`interval`

Data type: `Optional[String]`

The interval specifies the time interval between queue runs
for the queue group.  The parameter value should be an integer and
a letter (e.g. `10m`).  The letters `w` (week), `d` (day), `h` (hour),
`m` (minute) and `s` (second) are allowed.

Default value: ``undef``

##### <a name="jobs"></a>`jobs`

Data type: `Optional[Integer]`

This parameter limits the number of queue entries that will be
processed in a single queue run.

Default value: ``undef``

##### <a name="nice"></a>`nice`

Data type: `Optional[Integer]`

Set the nice-level for the queue group processor.  Using
a positive number will increase the nice-level by the given number.  This
results in the process to run with a reduced priority.

Default value: ``undef``

##### <a name="recipients"></a>`recipients`

Data type: `Optional[Integer]`

The number of recipients that are processed in a single
delivery before splitting.

Default value: ``undef``

##### <a name="runners"></a>`runners`

Data type: `Optional[Integer]`

The number of queue runners to lauch for this queue group.

Default value: ``undef``

##### <a name="path"></a>`path`

Data type: `Optional[Stdlib::Absolutepath]`

The location of the queue directory for this queue group.  The
parameter must be an absolute path and must be a subdirectory of the
default queue directory configured by the `QueueDirectory` option.

Default value: ``undef``

### <a name="sendmailmcversionid"></a>`sendmail::mc::versionid`

Add the `VERSIONID` macro to the sendmail.mc file.

#### Examples

##### Set the `VERSIONID` to the value `generic`

```puppet
sendmail::mc::versionid { 'generic': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::versionid` defined type:

* [`versionid`](#versionid)

##### <a name="versionid"></a>`versionid`

Data type: `String`

The identifier (a string) to set in the sendmail.mc file.

Default value: `$name`

### <a name="sendmailmcvirtuser_domain"></a>`sendmail::mc::virtuser_domain`

Add the `VIRTUSER_DOMAIN` macro to the sendmail.mc file.

#### Examples

##### 

```puppet
sendmail::mc::virtuser_domain { 'example.net': }
```

#### Parameters

The following parameters are available in the `sendmail::mc::virtuser_domain` defined type:

* [`domainname`](#domainname)

##### <a name="domainname"></a>`domainname`

Data type: `Stdlib::Fqdn`

The name of the domain to use with
`FEATURE(virtusertable)`.  This can be used multiple times to set more
than one domain name.

Default value: `$name`

### <a name="sendmailuserdbentry"></a>`sendmail::userdb::entry`

The type has an internal dependency to rebuild the database file.

#### Examples

##### Add an entry to the userdb

```puppet
sendmail::userdb::entry { 'fred:maildrop':
  value => 'fred@example.org',
}
```

#### Parameters

The following parameters are available in the `sendmail::userdb::entry` defined type:

* [`ensure`](#ensure)
* [`key`](#key)
* [`value`](#value)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the userdb db entry.  Valid options:
`present`, `absent`.

Default value: `'present'`

##### <a name="key"></a>`key`

Data type: `String`

The key used by Sendmail for the lookup.  This normally is in
the format `user:maildrop` or `user:mailname` where user is the a local
username.

Default value: `$name`

##### <a name="value"></a>`value`

Data type: `Optional[String]`

The value for the given key.  For the userdb map this is
typically a single mailaddress or a compound list of addresses separated
by commas.

Default value: ``undef``

### <a name="sendmailvirtusertableentry"></a>`sendmail::virtusertable::entry`

The type has an internal dependency to rebuild the database file.

#### Examples

##### Rewrite `info@example.com` to `fred@example.com`

```puppet
sendmail::virtusertable::entry { 'info@example.com':
  value => 'fred@example.com',
}
```

##### Rewrite all users in the `example.org` domain to a local user

```puppet
sendmail::virtusertable::entry { '@example.org':
  value => 'barney',
}
```

#### Parameters

The following parameters are available in the `sendmail::virtusertable::entry` defined type:

* [`ensure`](#ensure)
* [`key`](#key)
* [`value`](#value)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`

Used to create or remove the virtusertable db entry.  Valid
options: `present`, `absent`.

Default value: `'present'`

##### <a name="key"></a>`key`

Data type: `String`

The key used by Sendmail for the lookup.  This is normally
a mail address or a mail address without the user part.

Default value: `$name`

##### <a name="value"></a>`value`

Data type: `Optional[String]`

The value for the given key.  For the virtusertable map this
is typically a local username or a remote mail address.

Default value: ``undef``

## Functions

### <a name="sendmailcanonify_array"></a>`sendmail::canonify_array`

Type: Puppet Language

Rewrite the input array the following way:
- strip spaces from the beginning and end of each string
- remove duplicate entries
- sort the result

#### `sendmail::canonify_array(Array[String] $arg)`

Rewrite the input array the following way:
- strip spaces from the beginning and end of each string
- remove duplicate entries
- sort the result

Returns: `Array[String]` array of canonified strings

##### `arg`

Data type: `Array[String]`

array of strings to canonify

## Data types

### <a name="sendmaildhparam"></a>`Sendmail::DHParam`

The valid number of bits for DH params.

Alias of

```puppet
Variant[Enum['512','1024','2048'], Stdlib::Absolutepath]
```

### <a name="sendmaildeliverymode"></a>`Sendmail::Deliverymode`

The supported delivery modes for Sendmail.

Alias of

```puppet
Enum['b', 'background', 'd', 'deferred', 'i', 'interactive', 'q', 'queueonly']
```

### <a name="sendmailloglevel"></a>`Sendmail::Loglevel`

The supported loglevels.

Alias of

```puppet
Variant[Pattern[/^\d+$/], Integer]
```

### <a name="sendmailmessagesize"></a>`Sendmail::Messagesize`

A message size specification in bytes, kb or Mb.

Alias of

```puppet
Pattern[/^[0-9]*\s*([kM][bB])?$/]
```

### <a name="sendmailtimeout"></a>`Sendmail::Timeout`

A timeout specification in seconds or minutes.

Alias of

```puppet
Pattern[/^[0-9]+(s|m)?$/]
```

