# @summary Manage the Sendmail userdb file.
#
# @example
#   class { 'sendmail::userdb::file': }
#
# @param content The content of the file resource.
#
# @param source The source of the file resource.
#
#
class sendmail::userdb::file (
  Optional[String] $content = undef,
  Optional[String] $source  = undef,
) {
  include sendmail::params
  include sendmail::makeall

  file { $sendmail::params::userdb_file:
    ensure  => file,
    content => $content,
    source  => $source,
    owner   => $sendmail::params::sendmail_user,
    group   => $sendmail::params::sendmail_group,
    mode    => '0640',
    notify  => Class['sendmail::makeall'],
  }
}
